(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('ibm-wch-sdk-rendition-utils'), require('ibm-wch-sdk-ng'), require('@angular/core'), require('rxjs/BehaviorSubject'), require('rxjs/observable/combineLatest'), require('rxjs/observable/fromEvent'), require('rxjs/observable/of'), require('rxjs/operators/debounceTime'), require('rxjs/operators/distinctUntilChanged'), require('rxjs/operators/filter'), require('rxjs/operators/map'), require('rxjs/operators/mapTo'), require('rxjs/operators/shareReplay'), require('rxjs/operators/startWith'), require('rxjs/operators/switchMap'), require('rxjs/operators/switchMapTo'), require('rxjs/operators/takeUntil'), require('rxjs/operators/tap'), require('rxjs/ReplaySubject'), require('@angular/common'), require('ibm-wch-sdk-utils'), require('rxjs/Observable'), require('rxjs/observable/empty'), require('rxjs/operators/concatMap')) :
	typeof define === 'function' && define.amd ? define('ibm-wch-sdk-ng-rendition', ['exports', 'ibm-wch-sdk-rendition-utils', 'ibm-wch-sdk-ng', '@angular/core', 'rxjs/BehaviorSubject', 'rxjs/observable/combineLatest', 'rxjs/observable/fromEvent', 'rxjs/observable/of', 'rxjs/operators/debounceTime', 'rxjs/operators/distinctUntilChanged', 'rxjs/operators/filter', 'rxjs/operators/map', 'rxjs/operators/mapTo', 'rxjs/operators/shareReplay', 'rxjs/operators/startWith', 'rxjs/operators/switchMap', 'rxjs/operators/switchMapTo', 'rxjs/operators/takeUntil', 'rxjs/operators/tap', 'rxjs/ReplaySubject', '@angular/common', 'ibm-wch-sdk-utils', 'rxjs/Observable', 'rxjs/observable/empty', 'rxjs/operators/concatMap'], factory) :
	(factory((global['ibm-wch-sdk-ng-rendition'] = {}),global['ibm-wch-sdk-rendition-utils'],global['ibm-wch-sdk-ng'],global.ng.core,global.Rx,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx,global.ng.common,global['ibm-wch-sdk-utils'],global.Rx,global.Rx.Observable,global.Rx.Observable.prototype));
}(this, (function (exports,ibmWchSdkRenditionUtils,ibmWchSdkNg,core,BehaviorSubject,combineLatest,fromEvent,of,debounceTime,distinctUntilChanged,filter,map,mapTo,shareReplay,startWith,switchMap,switchMapTo,takeUntil,tap,ReplaySubject,common,ibmWchSdkUtils,Observable,empty,concatMap) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */
var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};
function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}









function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

var LOGGER = 'WchRenditionService';
var WchRenditionService = /** @class */ (function () {
    function WchRenditionService(aInjector) {
        var that = this;
        var loggerService = aInjector.get(ibmWchSdkNg.WchLoggerService);
        var logger = loggerService.get(LOGGER);
        function _getRenditionUrl(aWidth, aHeight, aImage) {
            return ibmWchSdkRenditionUtils.getRendition(aWidth, aHeight, aImage, logger).url;
        }
        function _getRendition(aWidth, aHeight, aImage) {
            return ibmWchSdkRenditionUtils.getRendition(aWidth, aHeight, aImage, logger);
        }
        that.getRenditionUrl = _getRenditionUrl;
        that.getRendition = _getRendition;
    }
    return WchRenditionService;
}());
WchRenditionService.decorators = [
    { type: core.Injectable },
];
WchRenditionService.ctorParameters = function () { return [
    { type: core.Injector, decorators: [{ type: core.Inject, args: [core.Injector,] },] },
]; };
var KEY_ON_RENDERING_CONTEXT = 'onRenderingContext';
var _mathRound = Math.round;
var jsonStringify = JSON.stringify;
function _equalDimension(aLeft, aRight) {
    return (aLeft === aRight) || ((aLeft.w === aRight.w) && (aLeft.h === aRight.h));
}
function _equalScaledImage(aLeft, aRight) {
    return (aLeft === aRight) || (_equalDimension(aLeft.img, aRight.img)
        && _equalDimension(aLeft.container, aRight.container) && (aLeft.url === aRight.url));
}
function _dimensionFromArray(aArray) {
    return ibmWchSdkRenditionUtils.createDimension(aArray[0], aArray[1]);
}
function _getMeasuredDimension(aElement, aRenderer, aLogger) {
    var ce = aElement;
    var w = 0, h = 0;
    while ((w <= 0) && ce) {
        ce = aRenderer.parentNode(ce);
        w = _mathRound(ce.clientWidth);
        h = _mathRound(ce.clientHeight);
    }
    aLogger.info('Measured dimension', w, 'x', h, 'via', ce);
    return ibmWchSdkRenditionUtils.createDimension(w, h);
}
var LOGGER$1 = 'WchRenditionDirective';
var RenditionDirective = /** @class */ (function (_super) {
    __extends(RenditionDirective, _super);
    function RenditionDirective(vcRef, parentRef, renderer, aInjector) {
        var _this = _super.call(this) || this;
        _this.onImage = new core.EventEmitter();
        var that = _this;
        var loggerService = aInjector.get(ibmWchSdkNg.WchLoggerService);
        var logger = loggerService.get(LOGGER$1);
        logger.info('Constructing ...');
        var onDestroy = that.onOnDestroy.pipe(shareReplay.shareReplay(1));
        var onInit = that.onOnInit.pipe(shareReplay.shareReplay(1));
        var onImage = new ReplaySubject.ReplaySubject(1);
        var onRelWidth = new BehaviorSubject.BehaviorSubject(0);
        var onRelHeight = new BehaviorSubject.BehaviorSubject(0);
        var onImgWidth = new BehaviorSubject.BehaviorSubject(0);
        var onImgHeight = new BehaviorSubject.BehaviorSubject(0);
        Object.defineProperties(that, {
            'wchRendition': that.describeSetter(onImage),
            'relWidth': that.describeSetter(onRelWidth),
            'relHeight': that.describeSetter(onRelHeight),
            'imgWidth': that.describeSetter(onImgWidth),
            'imgHeight': that.describeSetter(onImgHeight)
        });
        var onCurrentElement = onInit.pipe(mapTo.mapTo((parentRef.nativeElement)), filter.filter(Boolean), distinctUntilChanged.distinctUntilChanged());
        var onConfiguredDimension = onInit.pipe(switchMapTo.switchMapTo(combineLatest.combineLatest(onImgWidth, onImgHeight)), map.map(_dimensionFromArray), distinctUntilChanged.distinctUntilChanged(_equalDimension), tap.tap(function (d) { return logger.info('config', d); }));
        var onRelDimension = onInit.pipe(switchMapTo.switchMapTo(combineLatest.combineLatest(onRelWidth, onRelHeight)), map.map(_dimensionFromArray), distinctUntilChanged.distinctUntilChanged(_equalDimension), tap.tap(function (d) { return logger.info('rel', d); }));
        var onMeasuredDimension = onCurrentElement.pipe(switchMap.switchMap(function (ce) { return fromEvent.fromEvent(window, 'resize').pipe(startWith.startWith('start'), debounceTime.debounceTime(300), mapTo.mapTo(_getMeasuredDimension(ce, renderer, logger))); }), distinctUntilChanged.distinctUntilChanged(_equalDimension), tap.tap(function (d) { return logger.info('measured', d); }));
        var onSrcDimension = onConfiguredDimension.pipe(switchMap.switchMap(function (d) {
            var dw = d.w, dh = d.h;
            return ((dw > 0) && (dh > 0)) ? of.of(d) : onMeasuredDimension.pipe(map.map(function (dm) {
                var mw = dm.w, mh = dm.h;
                return (dw > 0) ? ibmWchSdkRenditionUtils.createDimension(dw, mh) : ((dh > 0) ? ibmWchSdkRenditionUtils.createDimension(mw, dh) : dm);
            }));
        }), distinctUntilChanged.distinctUntilChanged(_equalDimension), tap.tap(function (d) { return logger.info('src', d); }));
        var onDstDimension = onSrcDimension.pipe(switchMap.switchMap(function (sd) {
            var sw = sd.w, sh = sd.h;
            return onRelDimension.pipe(map.map(function (rd) {
                var rw = rd.w, rh = rd.h;
                return (rw > 0) ? ((rh > 0) ? ibmWchSdkRenditionUtils.createDimension(rw * sh, rh * sw) : ibmWchSdkRenditionUtils.createDimension(rw * sh, sh))
                    : ((rh > 0) ? ibmWchSdkRenditionUtils.createDimension(sw, rh * sw) : sd);
            }));
        }), distinctUntilChanged.distinctUntilChanged(_equalDimension), tap.tap(function (d) { return logger.info('dst', d); }));
        var onScaledImage = combineLatest.combineLatest(onImage.pipe(filter.filter(Boolean)), onDstDimension).pipe(map.map(function (_a) {
            var _b = __read(_a, 2), img = _b[0], d = _b[1];
            return ibmWchSdkRenditionUtils.getRendition(d.w, d.h, img, logger);
        }), distinctUntilChanged.distinctUntilChanged(_equalScaledImage), tap.tap(function (d) { return logger.info('url', jsonStringify(d)); }));
        var onRenderingContext = onInit.pipe(switchMap.switchMap(function () {
            var cmp = ((vcRef.injector)).view.component;
            return (cmp[KEY_ON_RENDERING_CONTEXT]);
        }));
        var onDeliveryUrl = onRenderingContext.pipe(filter.filter(Boolean), map.map(function (rc) { return rc.context.hub.deliveryUrl.origin; }), distinctUntilChanged.distinctUntilChanged());
        combineLatest.combineLatest(onDeliveryUrl, onScaledImage).pipe(map.map(function (_a) {
            var _b = __read(_a, 2), base = _b[0], img = _b[1];
            return Object.assign({}, img, { url: base + img.url });
        }), distinctUntilChanged.distinctUntilChanged(_equalScaledImage), tap.tap(function (img) { return logger.info('result', img); }), takeUntil.takeUntil(onDestroy))
            .subscribe(function (img) {
            var el = parentRef.nativeElement;
            renderer.setAttribute(el, 'src', img.url);
            renderer.setAttribute(el, 'width', img.container.w.toString());
            renderer.setAttribute(el, 'height', img.container.h.toString());
            that.onImage.emit(img);
        });
        return _this;
    }
    RenditionDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
    };
    RenditionDirective.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
    };
    return RenditionDirective;
}(ibmWchSdkNg.AbstractLifeCycleComponent));
RenditionDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[wchRendition]'
            },] },
];
RenditionDirective.ctorParameters = function () { return [
    { type: core.ViewContainerRef, },
    { type: core.ElementRef, },
    { type: core.Renderer2, },
    { type: core.Injector, decorators: [{ type: core.Inject, args: [core.Injector,] },] },
]; };
RenditionDirective.propDecorators = {
    "wchRendition": [{ type: core.Input },],
    "relHeight": [{ type: core.Input },],
    "relWidth": [{ type: core.Input },],
    "imgWidth": [{ type: core.Input },],
    "imgHeight": [{ type: core.Input },],
    "onImage": [{ type: core.Output },],
};
var SrcSetDirective = /** @class */ (function (_super) {
    __extends(SrcSetDirective, _super);
    function SrcSetDirective(vcRef, parentRef, renderer) {
        var _this = _super.call(this) || this;
        var that = _this;
        var onDestroy = that.onOnDestroy;
        var onInit = that.onOnInit;
        var onImage = new ReplaySubject.ReplaySubject(1);
        Object.defineProperties(that, {
            'wchSrcSet': _this.describeSetter(onImage)
        });
        var onRenderingContext = onInit.pipe(switchMap.switchMap(function () {
            var cmp = ((vcRef.injector)).view.component;
            return (cmp[KEY_ON_RENDERING_CONTEXT]);
        }));
        var onDeliveryUrl = onRenderingContext.pipe(filter.filter(Boolean), map.map(function (rc) { return rc.context.hub.deliveryUrl.origin; }), distinctUntilChanged.distinctUntilChanged());
        combineLatest.combineLatest(onDeliveryUrl, onImage).pipe(map.map(function (_a) {
            var _b = __read(_a, 2), origin = _b[0], img = _b[1];
            return ibmWchSdkRenditionUtils.getSourceSet(img, origin);
        }), distinctUntilChanged.distinctUntilChanged(), takeUntil.takeUntil(onDestroy))
            .subscribe(function (srcset) {
            var el = parentRef.nativeElement;
            renderer.setAttribute(el, 'srcset', srcset);
        });
        return _this;
    }
    SrcSetDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
    };
    SrcSetDirective.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
    };
    return SrcSetDirective;
}(ibmWchSdkNg.AbstractLifeCycleComponent));
SrcSetDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[wchSrcSet]'
            },] },
];
SrcSetDirective.ctorParameters = function () { return [
    { type: core.ViewContainerRef, },
    { type: core.ElementRef, },
    { type: core.Renderer2, },
]; };
SrcSetDirective.propDecorators = {
    "wchSrcSet": [{ type: core.Input },],
};
var WchNgRenditionComponentsModule = /** @class */ (function () {
    function WchNgRenditionComponentsModule() {
    }
    return WchNgRenditionComponentsModule;
}());
WchNgRenditionComponentsModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [
                    RenditionDirective,
                    SrcSetDirective
                ],
                providers: [],
                exports: [
                    RenditionDirective,
                    SrcSetDirective
                ],
                entryComponents: []
            },] },
];
var WchNgRenditionServicesModule = /** @class */ (function () {
    function WchNgRenditionServicesModule(parentModule) {
    }
    WchNgRenditionServicesModule.forRoot = function () {
        return {
            ngModule: WchNgRenditionServicesModule,
            providers: []
        };
    };
    return WchNgRenditionServicesModule;
}());
WchNgRenditionServicesModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [],
                providers: [
                    WchRenditionService
                ],
                exports: [],
                entryComponents: []
            },] },
];
WchNgRenditionServicesModule.ctorParameters = function () { return [
    { type: WchNgRenditionServicesModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf },] },
]; };
var WchNgRenditionModule = /** @class */ (function () {
    function WchNgRenditionModule(parentModule) {
    }
    WchNgRenditionModule.forRoot = function () {
        return {
            ngModule: WchNgRenditionModule,
            providers: []
        };
    };
    return WchNgRenditionModule;
}());
WchNgRenditionModule.decorators = [
    { type: core.NgModule, args: [{
                exports: [
                    WchNgRenditionComponentsModule,
                    WchNgRenditionServicesModule
                ]
            },] },
];
WchNgRenditionModule.ctorParameters = function () { return [
    { type: WchNgRenditionModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf },] },
]; };
var LOGGER$2 = 'WchIntersectionDirective';
var bHasIntersectionObserver = (typeof IntersectionObserver !== 'undefined');
var DEFAULT_ROOT_MARGIN = '0px';
var DEFAULT_THRESHOLD = 0;
var IntersectionDirective = /** @class */ (function (_super) {
    __extends(IntersectionDirective, _super);
    function IntersectionDirective(aElement, aInjector) {
        var _this = _super.call(this) || this;
        var rootMarginSubject = new BehaviorSubject.BehaviorSubject(DEFAULT_ROOT_MARGIN);
        var thresholdSubject = new BehaviorSubject.BehaviorSubject(DEFAULT_THRESHOLD);
        var setRootMargin = ibmWchSdkUtils.createSetterOnSubject(rootMarginSubject);
        var setThreshold = ibmWchSdkUtils.createSetterOnSubject(thresholdSubject);
        var that = _this;
        var wchLogger = aInjector.get(ibmWchSdkNg.WchLoggerService);
        var logger = wchLogger.get(LOGGER$2);
        if (bHasIntersectionObserver) {
            var zoneService = aInjector.get(ibmWchSdkNg.ZoneService);
            var onDestroy = that.onOnDestroy;
            var onRootMargin = rootMarginSubject.pipe(filter.filter(Boolean), distinctUntilChanged.distinctUntilChanged());
            var onThreshold = thresholdSubject.pipe(distinctUntilChanged.distinctUntilChanged());
            var onOptions = combineLatest.combineLatest(onRootMargin, onThreshold).pipe(map.map(function (_a) {
                var _b = __read(_a, 2), rootMargin = _b[0], threshold = _b[1];
                return ({ rootMargin: rootMargin, threshold: threshold });
            }), tap.tap(function (opt) { return logger.info('Intersection options', opt); }));
            var onIntersectionObserverEntry = onOptions.pipe(switchMap.switchMap(function (opt) { return Observable.Observable.create(function (ob) {
                var intersectObserver = new IntersectionObserver(ibmWchSdkUtils.createConsumerOnSubject(ob), opt);
                intersectObserver.observe(aElement.nativeElement);
                return function () { return intersectObserver.disconnect(); };
            }); }), zoneService.subscribeOutside(), zoneService.observeInside(), concatMap.concatMap(ibmWchSdkUtils.identity), tap.tap(function (data) { return logger.info('intersection event', data); }), takeUntil.takeUntil(onDestroy));
            that.onIntersect = onIntersectionObserverEntry;
        }
        else {
            logger.warn('IntersectionObserver not defined.');
            that.onIntersect = empty.empty();
        }
        Object.defineProperties(that, {
            'intersectRootMargin': setRootMargin,
            'intersectThreshold': setThreshold,
        });
        return _this;
    }
    IntersectionDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
    };
    IntersectionDirective.prototype.ngOnDestroy = function () {
        _super.prototype.ngOnDestroy.call(this);
    };
    return IntersectionDirective;
}(ibmWchSdkNg.AbstractLifeCycleComponent));
IntersectionDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[wchIntersect]'
            },] },
    { type: core.Injectable },
];
IntersectionDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: core.Injector, decorators: [{ type: core.Inject, args: [core.Injector,] },] },
]; };
IntersectionDirective.propDecorators = {
    "wchIntersect": [{ type: core.Input },],
    "intersectRootMargin": [{ type: core.Input },],
    "intersectThreshold": [{ type: core.Input },],
    "onIntersect": [{ type: core.Output },],
};
var WchNgIntersectionModule = /** @class */ (function () {
    function WchNgIntersectionModule() {
    }
    return WchNgIntersectionModule;
}());
WchNgIntersectionModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [
                    IntersectionDirective,
                ],
                exports: [
                    IntersectionDirective
                ]
            },] },
];

exports.ɵa = ibmWchSdkNg.AbstractLifeCycleComponent;
exports.WchRenditionService = WchRenditionService;
exports.RenditionDirective = RenditionDirective;
exports.SrcSetDirective = SrcSetDirective;
exports.WchNgRenditionModule = WchNgRenditionModule;
exports.WchNgRenditionServicesModule = WchNgRenditionServicesModule;
exports.WchNgRenditionComponentsModule = WchNgRenditionComponentsModule;
exports.WchNgIntersectionModule = WchNgIntersectionModule;
exports.IntersectionDirective = IntersectionDirective;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ibm-wch-sdk-ng-rendition.umd.js.map
